use std::{collections::HashMap, fs};

use anyhow::Result;
use endcap_sl_software_ri_generator::{generator::CodeGen, types};
use itertools::Itertools;

fn main() -> Result<()> {
    env_logger::init();

    println!("Hello, world!");
    let xmlfile = fs::read_to_string("./csr.xml")?;
    let doc = roxmltree::Document::parse_with_options(
        &xmlfile,
        roxmltree::ParsingOptions {
            allow_dtd: true,
            nodes_limit: u32::MAX,
        },
    )?;
    // println!("Parsed: {:#?}", doc);
    // println!("Root: {:?}", doc.root_element());

    let register_map = types::Module::from_xml_dom(doc.root_element())?;
    println!("read: {:#?}", register_map);

    println!("===========================================");

    let files = register_map.generate_register_interface(None, None, HashMap::new())?;
    println!("{:#?}", files);
    for filepath in files.keys().sorted() {
        println!("{}", filepath.display());
    }

    Ok(())
}
